# Interface ModuleResolver

#### Hierarchy

- ModuleResolver
  - ModuleRepository

#### Implemented by

- BridgeModuleResolver
- CompositeModuleResolver

- Defined in modules/packages/module/packages/model/dist/types/Module.d.ts:10

#####
Index

### Properties

addResolver
isModuleResolver
removeResolver

### Methods

resolve
resolveOne

## Properties

### addResolver

addResolver: ((resolver) => ModuleResolver)

#### Type declaration

- - (resolver): ModuleResolver

  - #### Parameters

    - ##### resolver: ModuleResolver

    #### Returns ModuleResolver

- Defined in modules/packages/module/packages/model/dist/types/Module.d.ts:11

### isModuleResolver

isModuleResolver: boolean

- Defined in modules/packages/module/packages/model/dist/types/Module.d.ts:12

### removeResolver

removeResolver: ((resolver) => ModuleResolver)

#### Type declaration

- - (resolver): ModuleResolver

  - #### Parameters

    - ##### resolver: ModuleResolver

    #### Returns ModuleResolver

- Defined in modules/packages/module/packages/model/dist/types/Module.d.ts:13

## Methods

### resolve

- resolve<T>(filter?): Promisable<T[], never>

- Resolves all modules matching the supplied filter. If no filter is supplied, all modules are returned

  #### Type Parameters

  - #### T extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, T> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### `Optional` filter: ModuleFilter

    Filter criteria for the desired modules

  #### Returns Promisable<T[], never>

  - Defined in modules/packages/module/packages/model/dist/types/Module.d.ts:19

### resolveOne

- resolveOne<T>(filter): Promisable<undefined | T, never>

- Resolves a single module, or undefined if no modules matched the filter.

  #### Type Parameters

  - #### T extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, T> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### filter: string

    The desired Module's Address or Name

  #### Returns Promisable<undefined | T, never>

  - Defined in modules/packages/module/packages/model/dist/types/Module.d.ts:24

Generated using TypeDoc